-- Compiled by Scene2Res, a MTA:SA GTA III engine map importer
local textureCache = {};
local streamedObjects = {};
local pModels = {};

setCloudsEnabled(false);
debug.sethook(nil);

local function getResourceSize(path)
	if not (fileExists(path)) then return 0; end;

	local file = fileOpen(path);
	local size = fileGetSize(file)

	fileClose(file);
	return size;
end

local function requestTexture(model, path)
	local txd = textureCache[path];

	if not (txd) then
		local size = getResourceSize(path);
		if (size == 0) then return false; end

		txd = engineLoadTXD(path, false);

		if not (txd) then
			return false;
		end

		textureCache[path] = txd;
	end
	return txd;
end

local function loadModel(model)
	if (model.loaded) then return true; end

	if (model.super) then
       local superModel = pModels[model.super];
       if (superModel) then
		    if not (loadModel(superModel)) then
			    return false;
		    end
       end
	end

	engineReplaceModel(model.model, model.id);
	engineReplaceCOL(model.col, model.id);

	model.loaded = true;
	return true;
end

local function freeModel(model)
	if not (model.loaded) then return true; end

	engineRestoreModel(model.id);
	engineRestoreCOL(model.id);

	model.loaded = false;
	if (model.super) then
       local superModel = pModels[model.super];
       if (superModel) then
		    freeModel(superModel);
       end
	end
end

function loadModels ()
	local pModel, pTXD, pColl, pTable;

	pTable={

	};

	for m,n in ipairs(pTable) do
		pModels[n[1]] = {
			id = n[1],
			name = n[2],
			txd = requestTexture(false, "textures/"..n[3]..".txd"),
			numStream = 0,
			lod = n[4] / 5,
			super = n[5]
		};
		pModelEntry = pModels[n[1]];
		engineImportTXD(pModelEntry.txd, n[1]);
		pModelEntry.model = engineLoadDFF("models/"..n[2]..".dff", n[1]);
		engineReplaceModel(pModelEntry.model, n[1]);
		if ( #n == 6 ) then
			pModelEntry.col = engineLoadCOL("coll/"..n[6]..".col");
			engineReplaceCOL(pModelEntry.col, n[1]);
		end
		engineSetModelLODDistance(n[1], n[4] / 5);
	end

	pTable={
		{ model=3994, model_file="zzpcad00", txd_file="zzpcad", coll_file="zzpcad00", lod=300 },
		{ model=3995, model_file="zzpcad01", txd_file="zzpcad", coll_file="zzpcad01", lod=300 },
		{ model=3996, model_file="zzpcad02", txd_file="zzpcad", coll_file="zzpcad02", lod=300 },
		{ model=3997, model_file="zzpcad03", txd_file="zzpcad", coll_file="zzpcad03", lod=300 },
		{ model=3998, model_file="zzpcad04", txd_file="zzpcad", coll_file="zzpcad04", lod=300 },
		{ model=3999, model_file="zzpcad05", txd_file="zzpcad", coll_file="zzpcad05", lod=300 },
		{ model=4000, model_file="zzpcad06", txd_file="zzpcad", coll_file="zzpcad06", lod=300 },
		{ model=4001, model_file="zzpcad07", txd_file="zzpcad", coll_file="zzpcad07", lod=300 },
		{ model=4002, model_file="zzpcad08", txd_file="zzpcad", coll_file="zzpcad08", lod=300 },
		{ model=4187, model_file="zzpcad09", txd_file="zzpcad", coll_file="zzpcad09", lod=300 },
		{ model=4004, model_file="zzpcad10", txd_file="zzpcad", coll_file="zzpcad10", lod=300 },
		{ model=4188, model_file="zzpcad11", txd_file="zzpcad", coll_file="zzpcad11", lod=300 },
		{ model=4006, model_file="zzpcad12", txd_file="zzpcad", coll_file="zzpcad12", lod=300 },
		{ model=4007, model_file="zzpcad13", txd_file="zzpcad", coll_file="zzpcad13", lod=300 },
		{ model=4008, model_file="zzpcad14", txd_file="zzpcad", coll_file="zzpcad14", lod=300 },
		{ model=4009, model_file="zzpcad15", txd_file="zzpcad", coll_file="zzpcad15", lod=300 },
		{ model=4010, model_file="zzpcad16", txd_file="zzpcad", coll_file="zzpcad16", lod=300 },
		{ model=4011, model_file="zzpcad17", txd_file="zzpcad", coll_file="zzpcad17", lod=300 },
		{ model=4012, model_file="zzpcad18", txd_file="zzpcad", coll_file="zzpcad18", lod=300 },
		{ model=4013, model_file="zzpcad19", txd_file="zzpcad", coll_file="zzpcad19", lod=300 },
		{ model=4014, model_file="zzpcad20", txd_file="zzpcad", coll_file="zzpcad20", lod=300 },
		{ model=4015, model_file="zzpcad21", txd_file="zzpcad", coll_file="zzpcad21", lod=300 },
		{ model=4016, model_file="zzpcad22", txd_file="zzpcad", coll_file="zzpcad22", lod=300 },
		{ model=4017, model_file="zzpcad23", txd_file="zzpcad", coll_file="zzpcad23", lod=300 },
		{ model=4018, model_file="zzpcad24", txd_file="zzpcad", coll_file="zzpcad24", lod=300 },
		{ model=4019, model_file="zzpcad25", txd_file="zzpcad", coll_file="zzpcad25", lod=300 },
		{ model=4020, model_file="zzpcad26", txd_file="zzpcad", coll_file="zzpcad26", lod=300 },
		{ model=4021, model_file="zzpcad27", txd_file="zzpcad", coll_file="zzpcad27", lod=300 },
		{ model=4022, model_file="zzpcad28", txd_file="zzpcad", coll_file="zzpcad28", lod=300 },
		{ model=4023, model_file="zzpcad29", txd_file="zzpcad", coll_file="zzpcad29", lod=300 },
		{ model=4024, model_file="zzpcad30", txd_file="zzpcad", coll_file="zzpcad30", lod=300 },
		{ model=4025, model_file="zzpcad31", txd_file="zzpcad", coll_file="zzpcad31", lod=300 },
		{ model=4026, model_file="zzpcad32", txd_file="zzpcad", coll_file="zzpcad32", lod=300 },
		{ model=4027, model_file="zzpcad33", txd_file="zzpcad", coll_file="zzpcad33", lod=300 },
		{ model=4028, model_file="zzpcad34", txd_file="zzpcad", coll_file="zzpcad34", lod=300 },
		{ model=4029, model_file="zzpcad35", txd_file="zzpcad", coll_file="zzpcad35", lod=300 },
		{ model=4030, model_file="zzpcad36", txd_file="zzpcad", coll_file="zzpcad36", lod=300 },
		{ model=4031, model_file="zzpcad37", txd_file="zzpcad", coll_file="zzpcad37", lod=300 },
		{ model=4032, model_file="zzpcad38", txd_file="zzpcad", coll_file="zzpcad38", lod=300 },
		{ model=4033, model_file="zzpcad39", txd_file="zzpcad", coll_file="zzpcad39", lod=300 },
		{ model=4034, model_file="zzpcad40", txd_file="zzpcad", coll_file="zzpcad40", lod=300 },
		{ model=4035, model_file="zzpcad41", txd_file="zzpcad", coll_file="zzpcad41", lod=300 },
		{ model=4036, model_file="zzpcad42", txd_file="zzpcad", coll_file="zzpcad42", lod=300 },
		{ model=4037, model_file="zzpcad43", txd_file="zzpcad", coll_file="zzpcad43", lod=300 },
		{ model=4038, model_file="zzpcad44", txd_file="zzpcad", coll_file="zzpcad44", lod=300 },
		{ model=4039, model_file="zzpcad45", txd_file="zzpcad", coll_file="zzpcad45", lod=300 },
		{ model=4040, model_file="zzpcad46", txd_file="zzpcad", coll_file="zzpcad46", lod=300 },
		{ model=4041, model_file="zzpcad47", txd_file="zzpcad", coll_file="zzpcad47", lod=300 },
		{ model=4042, model_file="zzpcad48", txd_file="zzpcad", coll_file="zzpcad48", lod=300 },
		{ model=4043, model_file="zzpcad49", txd_file="zzpcad", coll_file="zzpcad49", lod=300 },
		{ model=4044, model_file="zzpcad50", txd_file="zzpcad", coll_file="zzpcad50", lod=300 },
		{ model=4045, model_file="zzpcad51", txd_file="zzpcad", coll_file="zzpcad51", lod=300 },
		{ model=4046, model_file="zzpcad52", txd_file="zzpcad", coll_file="zzpcad52", lod=300 },
		{ model=4047, model_file="zzpcad53", txd_file="zzpcad", coll_file="zzpcad53", lod=300 },
		{ model=4048, model_file="zzpcad54", txd_file="zzpcad", coll_file="zzpcad54", lod=300 },
		{ model=4049, model_file="zzpcad55", txd_file="zzpcad", coll_file="zzpcad55", lod=300 },
		{ model=4050, model_file="zzpcad56", txd_file="zzpcad", coll_file="zzpcad56", lod=300 },
		{ model=4051, model_file="zzpcad57", txd_file="zzpcad", coll_file="zzpcad57", lod=300 },
		{ model=4052, model_file="zzpcad58", txd_file="zzpcad", coll_file="zzpcad58", lod=300 },
		{ model=4053, model_file="zzpcad59", txd_file="zzpcad", coll_file="zzpcad59", lod=300 },
		{ model=4054, model_file="zzpcad60", txd_file="zzpcad", coll_file="zzpcad60", lod=300 },
		{ model=4055, model_file="zzpcad61", txd_file="zzpcad", coll_file="zzpcad61", lod=300 },
		{ model=4056, model_file="zzpcad62", txd_file="zzpcad", coll_file="zzpcad62", lod=300 },
		{ model=4057, model_file="zzpcad63", txd_file="zzpcad", coll_file="zzpcad63", lod=300 },
		{ model=4058, model_file="zzpcad64", txd_file="zzpcad", coll_file="zzpcad64", lod=300 },
		{ model=4059, model_file="zzpcad65", txd_file="zzpcad", coll_file="zzpcad65", lod=300 },
		{ model=4060, model_file="zzpcad66", txd_file="zzpcad", coll_file="zzpcad66", lod=300 },
		{ model=4061, model_file="zzpcad67", txd_file="zzpcad", coll_file="zzpcad67", lod=300 },
		{ model=4062, model_file="zzpcad68", txd_file="zzpcad", coll_file="zzpcad68", lod=300 },
		{ model=4063, model_file="zzpcad69", txd_file="zzpcad", coll_file="zzpcad69", lod=300 },
		{ model=4064, model_file="zzpcad70", txd_file="zzpcad", coll_file="zzpcad70", lod=300 },
		{ model=4065, model_file="zzpcad71", txd_file="zzpcad", coll_file="zzpcad71", lod=300 },
		{ model=4066, model_file="zzpcad72", txd_file="zzpcad", coll_file="zzpcad72", lod=300 },
		{ model=4067, model_file="zzpcad73", txd_file="zzpcad", coll_file="zzpcad73", lod=300 },
		{ model=4068, model_file="zzpcad74", txd_file="zzpcad", coll_file="zzpcad74", lod=300 },
		{ model=4069, model_file="zzpcad75", txd_file="zzpcad", coll_file="zzpcad75", lod=300 },
		{ model=4070, model_file="zzpcad76", txd_file="zzpcad", coll_file="zzpcad76", lod=300 },
		{ model=4071, model_file="zzpcad77", txd_file="zzpcad", coll_file="zzpcad77", lod=300 },
		{ model=4072, model_file="zzpcad78", txd_file="zzpcad", coll_file="zzpcad78", lod=300 },
		{ model=4073, model_file="zzpcad79", txd_file="zzpcad", coll_file="zzpcad79", lod=300 },
		{ model=4074, model_file="zzpcad80", txd_file="zzpcad", coll_file="zzpcad80", lod=300 },
		{ model=4075, model_file="zzpcad81", txd_file="zzpcad", coll_file="zzpcad81", lod=300 },
		{ model=4076, model_file="zzpcad82", txd_file="zzpcad", coll_file="zzpcad82", lod=300 },
		{ model=4077, model_file="zzpcad83", txd_file="zzpcad", coll_file="zzpcad83", lod=300 },
		{ model=4078, model_file="zzpcad84", txd_file="zzpcad", coll_file="zzpcad84", lod=300 },
		{ model=4079, model_file="zzpcad85", txd_file="zzpcad", coll_file="zzpcad85", lod=300 },
		{ model=4080, model_file="zzpcad86", txd_file="zzpcad", coll_file="zzpcad86", lod=300 },
		{ model=4081, model_file="zzpcad87", txd_file="zzpcad", coll_file="zzpcad87", lod=300 },
		{ model=4082, model_file="zzpcad88", txd_file="zzpcad", coll_file="zzpcad88", lod=300 },
		{ model=4083, model_file="zzpcad89", txd_file="zzpcad", coll_file="zzpcad89", lod=300 },
		{ model=4085, model_file="zzpcad90", txd_file="zzpcad", coll_file="zzpcad90", lod=300 },
		{ model=4086, model_file="zzpcad91", txd_file="zzpcad", coll_file="zzpcad91", lod=300 },
		{ model=4087, model_file="zzpcad92", txd_file="zzpcad", coll_file="zzpcad92", lod=300 },
		{ model=4088, model_file="zzpcad93", txd_file="zzpcad", coll_file="zzpcad93", lod=300 },
		{ model=4089, model_file="zzpcad94", txd_file="zzpcad", coll_file="zzpcad94", lod=300 },
		{ model=4090, model_file="zzpcad95", txd_file="zzpcad", coll_file="zzpcad95", lod=300 },
		{ model=4091, model_file="zzpcad96", txd_file="zzpcad", coll_file="zzpcad96", lod=300 },
		{ model=4092, model_file="zzpcad97", txd_file="zzpcad", coll_file="zzpcad97", lod=300 },
		{ model=4093, model_file="zzpcad98", txd_file="zzpcad", coll_file="zzpcad98", lod=300 },
		{ model=4094, model_file="zzpcad99", txd_file="zzpcad", coll_file="zzpcad99", lod=300 },
		{ model=4095, model_file="zzpcad100", txd_file="zzpcad", coll_file="zzpcad100", lod=300 },
		{ model=4096, model_file="zzpcad101", txd_file="zzpcad", coll_file="zzpcad101", lod=300 },
		{ model=4097, model_file="zzpcad102", txd_file="zzpcad", coll_file="zzpcad102", lod=300 },
		{ model=4098, model_file="zzpcad103", txd_file="zzpcad", coll_file="zzpcad103", lod=300 },
		{ model=4099, model_file="zzpcad104", txd_file="zzpcad", coll_file="zzpcad104", lod=300 },
		{ model=4100, model_file="zzpcad105", txd_file="zzpcad", coll_file="zzpcad105", lod=300 },
		{ model=4101, model_file="zzpcad106", txd_file="zzpcad", coll_file="zzpcad106", lod=300 },
		{ model=4102, model_file="zzpcad107", txd_file="zzpcad", coll_file="zzpcad107", lod=300 },
		{ model=4103, model_file="zzpcad108", txd_file="zzpcad", coll_file="zzpcad108", lod=300 },
		{ model=4104, model_file="zzpcad109", txd_file="zzpcad", coll_file="zzpcad109", lod=300 },
		{ model=3976, model_file="zzplpdouble", txd_file="zzpcad", coll_file="zzplpdouble", lod=300 },
		{ model=3977, model_file="zzplp", txd_file="zzpcad", coll_file="zzplp", lod=300 },
		{ model=3978, model_file="zzpcad196", txd_file="zzpcad", coll_file="zzpcad196", lod=300 },
		{ model=3979, model_file="zzpcad202", txd_file="zzpcad", coll_file="zzpcad202", lod=300 },
		{ model=3980, model_file="zzpcad200", txd_file="zzpcad", coll_file="zzpcad200", lod=300 },
		{ model=3981, model_file="zzpcad201", txd_file="zzpcad", coll_file="zzpcad201", lod=300 },
		{ model=3982, model_file="zzpcad204", txd_file="zzpcad", coll_file="zzpcad204", lod=300 },
		{ model=3983, model_file="zzpcad209", txd_file="zzpcad", coll_file="zzpcad209", lod=300 },
		{ model=3984, model_file="zzpcad199", txd_file="zzpcad", coll_file="zzpcad199", lod=300 },
		{ model=3985, model_file="zzpcad198", txd_file="zzpcad", coll_file="zzpcad198", lod=300 },
		{ model=3986, model_file="zzpcad195", txd_file="zzpcad", coll_file="zzpcad195", lod=300 },
		{ model=3987, model_file="zzpcad208", txd_file="zzpcad", coll_file="zzpcad208", lod=300 },
		{ model=3988, model_file="zzpcad206", txd_file="zzpcad", coll_file="zzpcad206", lod=300 },
		{ model=3989, model_file="zzpcad207", txd_file="zzpcad", coll_file="zzpcad207", lod=300 },
		{ model=3990, model_file="zzpcad205", txd_file="zzpcad", coll_file="zzpcad205", lod=300 },
		{ model=3991, model_file="zzpcad203", txd_file="zzpcad", coll_file="zzpcad203", lod=300 },
		{ model=3992, model_file="zzpcad197", txd_file="zzpcad", coll_file="zzpcad197", lod=300 },
		{ model=3993, model_file="zzpcad194", txd_file="zzpcad", coll_file="zzpcad194", lod=300 },
		{ model=4105, model_file="zzpcad110", txd_file="zzpcad", coll_file="zzpcad110", lod=300 },
		{ model=4106, model_file="zzpcad111", txd_file="zzpcad", coll_file="zzpcad111", lod=300 },
		{ model=4107, model_file="zzpcad112", txd_file="zzpcad", coll_file="zzpcad112", lod=300 },
		{ model=4108, model_file="zzpcad113", txd_file="zzpcad", coll_file="zzpcad113", lod=300 },
		{ model=4109, model_file="zzpcad114", txd_file="zzpcad", coll_file="zzpcad114", lod=300 },
		{ model=4110, model_file="zzpcad115", txd_file="zzpcad", coll_file="zzpcad115", lod=300 },
		{ model=4111, model_file="zzpcad116", txd_file="zzpcad", coll_file="zzpcad116", lod=300 },
		{ model=4112, model_file="zzpcad117", txd_file="zzpcad", coll_file="zzpcad117", lod=300 },
		{ model=4113, model_file="zzpcad118", txd_file="zzpcad", coll_file="zzpcad118", lod=300 },
		{ model=4114, model_file="zzpcad119", txd_file="zzpcad", coll_file="zzpcad119", lod=300 },
		{ model=4115, model_file="zzpcad120", txd_file="zzpcad", coll_file="zzpcad120", lod=300 },
		{ model=4116, model_file="zzpcad121", txd_file="zzpcad", coll_file="zzpcad121", lod=300 },
		{ model=4117, model_file="zzpcad122", txd_file="zzpcad", coll_file="zzpcad122", lod=300 },
		{ model=4118, model_file="zzpcad123", txd_file="zzpcad", coll_file="zzpcad123", lod=300 },
		{ model=4119, model_file="zzpcad124", txd_file="zzpcad", coll_file="zzpcad124", lod=300 },
		{ model=4120, model_file="zzpcad125", txd_file="zzpcad", coll_file="zzpcad125", lod=300 },
		{ model=4121, model_file="zzpcad126", txd_file="zzpcad", coll_file="zzpcad126", lod=300 },
		{ model=4122, model_file="zzpcad127", txd_file="zzpcad", coll_file="zzpcad127", lod=300 },
		{ model=4123, model_file="zzpcad128", txd_file="zzpcad", coll_file="zzpcad128", lod=300 },
		{ model=4124, model_file="zzpcad129", txd_file="zzpcad", coll_file="zzpcad129", lod=300 },
		{ model=4125, model_file="zzpcad130", txd_file="zzpcad", coll_file="zzpcad130", lod=300 },
		{ model=4126, model_file="zzpcad131", txd_file="zzpcad", coll_file="zzpcad131", lod=300 },
		{ model=4127, model_file="zzpcad132", txd_file="zzpcad", coll_file="zzpcad132", lod=300 },
		{ model=4128, model_file="zzpcad133", txd_file="zzpcad", coll_file="zzpcad133", lod=300 },
		{ model=4129, model_file="zzpcad134", txd_file="zzpcad", coll_file="zzpcad134", lod=300 },
		{ model=4130, model_file="zzpcad135", txd_file="zzpcad", coll_file="zzpcad135", lod=300 },
		{ model=4131, model_file="zzpcad136", txd_file="zzpcad", coll_file="zzpcad136", lod=300 },
		{ model=4132, model_file="zzpcad137", txd_file="zzpcad", coll_file="zzpcad137", lod=300 },
		{ model=4133, model_file="zzpcad138", txd_file="zzpcad", coll_file="zzpcad138", lod=300 },
		{ model=4134, model_file="zzpcad139", txd_file="zzpcad", coll_file="zzpcad139", lod=300 },
		{ model=4135, model_file="zzpcad140", txd_file="zzpcad", coll_file="zzpcad140", lod=300 },
		{ model=4136, model_file="zzpcad141", txd_file="zzpcad", coll_file="zzpcad141", lod=300 },
		{ model=4137, model_file="zzpcad142", txd_file="zzpcad", coll_file="zzpcad142", lod=300 },
		{ model=4138, model_file="zzpcad143", txd_file="zzpcad", coll_file="zzpcad143", lod=300 },
		{ model=4139, model_file="zzpcad144", txd_file="zzpcad", coll_file="zzpcad144", lod=300 },
		{ model=4140, model_file="zzpcad145", txd_file="zzpcad", coll_file="zzpcad145", lod=300 },
		{ model=4141, model_file="zzpcad146", txd_file="zzpcad", coll_file="zzpcad146", lod=300 },
		{ model=4142, model_file="zzpcad147", txd_file="zzpcad", coll_file="zzpcad147", lod=300 },
		{ model=4143, model_file="zzpcad148", txd_file="zzpcad", coll_file="zzpcad148", lod=300 },
		{ model=4144, model_file="zzpcad149", txd_file="zzpcad", coll_file="zzpcad149", lod=300 },
		{ model=4145, model_file="zzpcad150", txd_file="zzpcad", coll_file="zzpcad150", lod=300 },
		{ model=4146, model_file="zzpcad151", txd_file="zzpcad", coll_file="zzpcad151", lod=300 },
		{ model=4147, model_file="zzpcad152", txd_file="zzpcad", coll_file="zzpcad152", lod=300 },
		{ model=4148, model_file="zzpcad153", txd_file="zzpcad", coll_file="zzpcad153", lod=300 },
		{ model=4149, model_file="zzpcad154", txd_file="zzpcad", coll_file="zzpcad154", lod=300 },
		{ model=4150, model_file="zzpcad155", txd_file="zzpcad", coll_file="zzpcad155", lod=300 },
		{ model=4151, model_file="zzpcad156", txd_file="zzpcad", coll_file="zzpcad156", lod=300 },
		{ model=4152, model_file="zzpcad157", txd_file="zzpcad", coll_file="zzpcad157", lod=300 },
		{ model=4153, model_file="zzpcad158", txd_file="zzpcad", coll_file="zzpcad158", lod=300 },
		{ model=4154, model_file="zzpcad159", txd_file="zzpcad", coll_file="zzpcad159", lod=300 },
		{ model=4155, model_file="zzpcad160", txd_file="zzpcad", coll_file="zzpcad160", lod=300 },
		{ model=4156, model_file="zzpcad161", txd_file="zzpcad", coll_file="zzpcad161", lod=300 },
		{ model=4157, model_file="zzpcad162", txd_file="zzpcad", coll_file="zzpcad162", lod=300 },
		{ model=4158, model_file="zzpcad163", txd_file="zzpcad", coll_file="zzpcad163", lod=300 },
		{ model=4159, model_file="zzpcad164", txd_file="zzpcad", coll_file="zzpcad164", lod=300 },
		{ model=4160, model_file="zzpcad165", txd_file="zzpcad", coll_file="zzpcad165", lod=300 },
		{ model=4161, model_file="zzpcad166", txd_file="zzpcad", coll_file="zzpcad166", lod=300 },
		{ model=4162, model_file="zzpcad167", txd_file="zzpcad", coll_file="zzpcad167", lod=300 },
		{ model=4163, model_file="zzpcad168", txd_file="zzpcad", coll_file="zzpcad168", lod=300 },
		{ model=4164, model_file="zzpcad169", txd_file="zzpcad", coll_file="zzpcad169", lod=300 },
		{ model=4165, model_file="zzpcad170", txd_file="zzpcad", coll_file="zzpcad170", lod=300 },
		{ model=4166, model_file="zzpcad171", txd_file="zzpcad", coll_file="zzpcad171", lod=300 },
		{ model=4167, model_file="zzpcad172", txd_file="zzpcad", coll_file="zzpcad172", lod=300 },
		{ model=4168, model_file="zzpcad173", txd_file="zzpcad", coll_file="zzpcad173", lod=300 },
		{ model=4169, model_file="zzpcad174", txd_file="zzpcad", coll_file="zzpcad174", lod=300 },
		{ model=4170, model_file="zzpcad175", txd_file="zzpcad", coll_file="zzpcad175", lod=300 },
		{ model=4171, model_file="zzpcad193", txd_file="zzpcad", coll_file="zzpcad193", lod=300 },
		{ model=4172, model_file="zzpcad177", txd_file="zzpcad", coll_file="zzpcad177", lod=300 },
		{ model=4173, model_file="zzpcad178", txd_file="zzpcad", coll_file="zzpcad178", lod=300 },
		{ model=4174, model_file="zzpcad179", txd_file="zzpcad", coll_file="zzpcad179", lod=300 },
		{ model=4175, model_file="zzpcad180", txd_file="zzpcad", coll_file="zzpcad180", lod=300 },
		{ model=4176, model_file="zzpcad181", txd_file="zzpcad", coll_file="zzpcad181", lod=300 },
		{ model=4177, model_file="zzpcad182", txd_file="zzpcad", coll_file="zzpcad182", lod=300 },
		{ model=4178, model_file="zzpcad183", txd_file="zzpcad", coll_file="zzpcad183", lod=300 },
		{ model=4179, model_file="zzpcad184", txd_file="zzpcad", coll_file="zzpcad184", lod=300 },
		{ model=4180, model_file="zzpcad176", txd_file="zzpcad", coll_file="zzpcad176", lod=300 },
		{ model=4181, model_file="zzpcad186", txd_file="zzpcad", coll_file="zzpcad186", lod=300 },
		{ model=4182, model_file="zzpcad187", txd_file="zzpcad", coll_file="zzpcad187", lod=300 },
		{ model=4183, model_file="zzpcad188", txd_file="zzpcad", coll_file="zzpcad188", lod=300 },
		{ model=4184, model_file="zzpcad189", txd_file="zzpcad", coll_file="zzpcad189", lod=300 },
		{ model=4185, model_file="zzpcad190", txd_file="zzpcad", coll_file="zzpcad190", lod=300 },
		{ model=4005, model_file="zzpcad191", txd_file="zzpcad", coll_file="zzpcad191", lod=300 },
		{ model=4003, model_file="zzpcad192", txd_file="zzpcad", coll_file="zzpcad192", lod=300 },
		{ model=4186, model_file="zzpcad185", txd_file="zzpcad", coll_file="zzpcad185", lod=300 },
		{ model=3975, model_file="zzpcadLight1", txd_file="zzpcad", coll_file="zzpcadLight1", lod=300 },
		{ model=4189, model_file="zzpcad220", txd_file="zzpcad", coll_file="zzpcad220", lod=300 },
		{ model=4190, model_file="zzpcad221", txd_file="zzpcad", coll_file="zzpcad221", lod=300 },
		{ model=4191, model_file="zzpcad222", txd_file="zzpcad", coll_file="zzpcad222", lod=300 },
		{ model=4192, model_file="zzpcad223", txd_file="zzpcad", coll_file="zzpcad223", lod=300 },
		{ model=4193, model_file="zzpcad224", txd_file="zzpcad", coll_file="zzpcad224", lod=300 },
		{ model=4194, model_file="zzpcad225", txd_file="zzpcad", coll_file="zzpcad225", lod=300 },
		{ model=4195, model_file="zzpcad226", txd_file="zzpcad", coll_file="zzpcad226", lod=300 },
		{ model=4196, model_file="zzpcad227", txd_file="zzpcad", coll_file="zzpcad227", lod=300 },
		{ model=4197, model_file="zzpcad228", txd_file="zzpcad", coll_file="zzpcad228", lod=300 },
		{ model=4198, model_file="zzpcad229", txd_file="zzpcad", coll_file="zzpcad229", lod=300 },
		{ model=4199, model_file="zzpcad230", txd_file="zzpcad", coll_file="zzpcad230", lod=300 },
		{ model=4200, model_file="zzpcad231", txd_file="zzpcad", coll_file="zzpcad231", lod=300 },
		{ model=4201, model_file="zzpcad232", txd_file="zzpcad", coll_file="zzpcad232", lod=300 },
		{ model=4202, model_file="zzpcad233", txd_file="zzpcad", coll_file="zzpcad233", lod=300 },
		{ model=4203, model_file="zzpcad234", txd_file="zzpcad", coll_file="zzpcad234", lod=300 },
		{ model=4204, model_file="zzpcad235", txd_file="zzpcad", coll_file="zzpcad235", lod=300 },
		{ model=4205, model_file="zzpcad236", txd_file="zzpcad", coll_file="zzpcad236", lod=300 },
		{ model=4206, model_file="zzpcad237", txd_file="zzpcad", coll_file="zzpcad237", lod=300 },
		{ model=4207, model_file="zzpcad238", txd_file="zzpcad", coll_file="zzpcad238", lod=300 },
		{ model=4208, model_file="zzpcad239", txd_file="zzpcad", coll_file="zzpcad239", lod=300 },
		{ model=4209, model_file="zzpcad240", txd_file="zzpcad", coll_file="zzpcad240", lod=300 },
		{ model=4210, model_file="zzpcad241", txd_file="zzpcad", coll_file="zzpcad241", lod=300 },
		{ model=4211, model_file="zzpcad242", txd_file="zzpcad", coll_file="zzpcad242", lod=300 },
		{ model=4223, model_file="zzpcad243", txd_file="zzpcad", coll_file="zzpcad243", lod=300 },
		{ model=4224, model_file="zzpcad244", txd_file="zzpcad", coll_file="zzpcad244", lod=300 },
		{ model=4225, model_file="zzpcad245", txd_file="zzpcad", coll_file="zzpcad245", lod=300 },
		{ model=4226, model_file="zzpcad246", txd_file="zzpcad", coll_file="zzpcad246", lod=300 },
		{ model=4227, model_file="zzpcad247", txd_file="zzpcad", coll_file="zzpcad247", lod=300 },
		{ model=4228, model_file="zzpcad248", txd_file="zzpcad", coll_file="zzpcad248", lod=300 },
		{ model=4229, model_file="zzpcad249", txd_file="zzpcad", coll_file="zzpcad249", lod=300 },
		{ model=4230, model_file="zzpcad250", txd_file="zzpcad", coll_file="zzpcad250", lod=300 },
		{ model=4231, model_file="zzpcad251", txd_file="zzpcad", coll_file="zzpcad251", lod=300 },
		{ model=4232, model_file="zzpcad252", txd_file="zzpcad", coll_file="zzpcad252", lod=300 },
		{ model=4233, model_file="zzpcad253", txd_file="zzpcad", coll_file="zzpcad253", lod=300 }
	};

	local n,m;

	for n,m in ipairs(pTable) do
		pModels[m.model] = {
			id = m.model,
			name = m.model_file,
			txd = requestTexture(false, "textures/"..m.txd_file..".txd"),
			numStream = 0,
			lod = m.lod,
			lodID = m.lodID
		};
		pModelEntry = pModels[m.model];
       if (pModelEntry.txd) then
		    engineImportTXD(pModelEntry.txd, m.model);
       end
		pModelEntry.model=engineLoadDFF("models/"..m.model_file..".dff", m.model);
		pModelEntry.col=engineLoadCOL("coll/"..m.coll_file..".col");
		engineSetModelLODDistance(m.model, m.lod);

		if (m.lodID) then
			for j,k in ipairs(getElementsByType("object", resourceRoot)) do
				if (getElementModel(k) == m.model) then
					local x, y, z = getElementPosition(k);
					local rx, ry, rz = getElementRotation(k);
					setLowLODElement(k, createObject(m.lodID, x, y, z, rx, ry, rz, true));
				end
			end
		end
	end

	for m,n in pairs(pModels) do
		if (n.super) and not (n.col) then
           local superModel = pModels[n.super];
           if (superModel) then
			    n.col = superModel.col;
           end
		end
	end
end
loadModels();

for m,n in pairs(pModels) do
    loadModel(n);
end

addEventHandler("onClientResourceStop", resourceRoot, function()
		for m,n in pairs(pModels) do
			if (isElement(n.col)) then destroyElement(n.col); end
			if (isElement(n.model)) then destroyElement(n.model); end
			engineRestoreCOL(m);
			engineRestoreModel(m);
		end
       for m,n in pairs(textureCache) do
           destroyElement(n);
       end
	end
);

collectgarbage("collect");
